# Moodle plugin « Point of View »

*Quentin Fombaron - October 20<SUP>th</SUP> 2020*<br />
*Centre des Nouvelles Pédagogies (CNP\*), Univ. Grenoble Alpes - University of  innovation*<br />

The plugin **Point of view** offers the possibility to react and give difficulty levels to activities of a Moodle course. Students know the difficulty of the activity thank to color tracks, they also have the possibility to react via emojis, each representing an emotion, a feeling (see **Usage** section).

It is a Moodle plugin managed by a block to be added in a course (see **0.1** part).

This plugin is developed by Quentin Fombaron. It is initialy developped for [caseine.org](http://www.caseine.org). Do not hesitate to send your thinking and bug reports to the contact addresses bellow.

Contacts :
- [Quentin Fombaron](mailto:q.fombaron@outlook.fr)
- [Caseine](mailto:contact.caseine@grenoble-inp.fr)

<br />\* *The CNP, set up as part of the IDEX Training component, brings together the DAPI, PerForm and IDEX support teams.*<br />

## Block

### 0.1 - Add the block to a course

<img src='https://i.imgur.com/xzkxGdD.png' alt='0.1.1' width='250px' /><br />

On the course page, in the side panel, click the `Add a Block` button, then in the block list, choose `Point of View`. The block is then added; all that remains is to configure it (See **Configuration** section).

### 0.2 Delete the block of a course

<img src='https://i.imgur.com/KTGmG31.png' alt='0.2.1' width='250px' /><br />

Once the block has been added (see **0.1** part), switch to edit mode then click on the `Actions` icon (⚙️ a gear), then `Delete Point of View block`.

<img src='https://i.imgur.com/AI48l1c.png' alt='0.2.2' width='250px' />

### 0.3 Configuration page access

<img src='https://i.imgur.com/KTGmG31.png' alt='0.3.1' width='250px' /><br />

Once the block has been added (see **0.1** part), switch to edit mode then click on the `Actions` icon (⚙️ a gear), then `Configure the Point of View block`.

<img src='https://i.imgur.com/TXzODfL.png' alt='0.3.2' width='250px' />

## Usage

**Important to know :**
- Only **3** possible reactions are available ("Easy", "I'm getting better" and "So hard" by default).
- Only **4** possible difficulty tracks (Green, Blue, Red and Black by default) are available.

### 1.0 - How to display the details of an activity's reactions?

<img src='https://i.imgur.com/be3aPgr.png' alt='1.0.1' height='50px' /><br />

The emojis are initially grouped; it is enough to leave the mouse on the group so that the detail is displayed.

<img src='https://i.imgur.com/SjqJQJg.png' alt='1.0.2' width='250px' />

### 1.1 - How to react to an activity?

<img src='https://i.imgur.com/iGzc2Zl.png' alt='1.1.1' width='250px' /><br />

Once the voting details are displayed (see **1.0** part), move the mouse under each emoji to have the associated reaction.

<img src='https://i.imgur.com/BCrwdOE.png' alt='1.1.2' width='250px' /><br />

Voting by clicking on the desired emoji, the number of votes for the associated reaction increments and turns blue. If the reaction had no vote and was therefore in black and white, it becomes in color.

**Important** : One and only one vote is possible per user and per activity.

### 1.2 - How to change of vote?

<img src='https://i.imgur.com/4ArKvFq.png' alt='1.2.1' width='250px' /><br />

Once a vote has been taken (see **1.1** part), modify its vote by clicking on another reaction, the number of votes will then be automatically updated.

### 1.3 - How to delete of vote?

<img src='https://i.imgur.com/85N9Buy.png' alt='1.3.1' width='250px' /><br />

Once a vote has been taken (see **1.1** part), delete this vote by clicking again on the voted activity. The vote will then be deleted.

### 1.4 - How to know the difficulty of an activity?

<img src='https://i.imgur.com/njUZ4l3.png' alt='1.4.1' width='500px' /><br />

Once it was configured (see **3.3** part), the difficulty track is displayed at the left of the activity name.

## Configuration

### 2.0 - How to enable the reaction system?

<img src='https://i.imgur.com/bkYlOqS.png' alt='2.0.1' width='400px' /><br />

On the plugin configuration page, in the `Block setting` tab, check/uncheck the box to enable/disable the reaction system. The activity activation and emojis customization options will be automatically hidden if the checkbox is unchecked.

### 2.1  - How to enable the Difficulty tracks?

<img src='https://i.imgur.com/QTJEJ99.png' alt='2.1.1' width='400px' /><br />

On the plugin configuration page, in the `Block setting` tab, check/uncheck the box to enable/disable the difficulty tracks. The activation options on the activities will be automatically hidden if the box is unchecked.

### 3.0 - How to enable reactions on an activity?

<img src='https://i.imgur.com/QYE7U25.png' alt='3.0.1' width='400px' /><br />

Once the reaction system is enabled (see **2.0** part), in the ` Configuration of Reactions and Difficulty Tracks` tab, enable reactions on an activity by simply checking the box to the right of the name of the associated activity.

### 3.1 - How to activate reactions on all activities of the same type?

<img src='https://i.imgur.com/ils6HG0.png' alt='3.1.1' width='400px' /><br />

Once the reaction system is enabled (see **2.0** part), in the tab `Configuration of Reactions and Difficulty Tracks`, enable/disable reactions on all activities of the same type by clicking on the associated buttons. For example on the image above, the management of all resources.

### 3.2 - How to enable the reactions on all the activities of the same course?

<img src='https://i.imgur.com/y5ad5OC.png' alt='3.2.1' width='600px' /><br />

Once the reaction system is enabled (see **2.0** part), in the tab `Configuration of Reactions and Difficulty Tracks`, enable/disable the reactions on all the activities of the same course by clicking on the associated button.

### 3.3 - How to define difficulty tracks?

<img src='https://i.imgur.com/lsrS7iK.png' alt='3.3.1' width='400px' /><br />

Once the difficulty tracks are enabled (see **2.1** part), in the `Configuration of Reactions and Difficulty Tracks` tab, define a track to a course by choosing in the drop-down list to the right of the associated activity.

<img src='https://i.imgur.com/WMirurL.png' alt='3.3.2' width='200px' />

### 3.4 - How to use the navigation buttons?

<img src='https://i.imgur.com/s7qgHCR.png' alt='3.4.1' width='150px' /><br />

In the `Configuration of Reaction and Difficulty Tracks` tab, two buttons facilitate navigation.`Save` saves the configuration.`Close Tab` closes the `Configuration of Reaction and Difficulty Tracks` tab.

### 4.0 - How to customize emojis?

<img src='https://i.imgur.com/zrFKnDC.png' alt='4.0.1' width='350px' /><br />

Once the reaction system is enabled (see **2.0** part), in the tab `Configuration of Emojis`, activate the emojis customization by checking the box above.

Then provide the required 11 files in the file area.

<img src='https://i.imgur.com/lvmHzy7.png' alt='4.0.2' width='700px' /><br />

11 files are needed, 3 emojis, 7 emoji groups (all possible groups from 1 to 3 emojis) and 1 neutral emoji meaning no vote on the activity.

Exemple : 

<img src='https://i.imgur.com/acoB3d0.png' alt='4.0.3' width='700px' /><br />

|                          | Emojis                               | Emojis group                                                                                                     | None vote emoji      |
| ------------------------ |:------------------------------------:|:----------------------------------------------------------------------------------------------------------------:|:--------------------:| 
| **File names**           | easy.png<br/>better.png<br/>hard.png | group_E.png<br/>group_B.png<br/>group_H.png<br/>group_EB.png<br/>group_EH.png<br/>group_BH.png<br/>group_EBH.png | group_.png           |
| **Sizes**                | 200x200                              | 400x200                                                                                                          | 400x200              |
| **Extensions**           | PNG                                  | PNG                                                                                                              | PNG                  |

### 4.1- How to restore emojis by default? 

<img src='https://i.imgur.com/RptnjSt.png' alt='4.1.1' width='800px' /><br />

Once the reaction system is enabled (see **2.0** part), in the tab `Configuration of Emojis`, reset emojis by pressing the button `Reset emojis`. You will be automatically redirected to the course page.

### 4.2 - How to modify the text associated with an emoji?

<img src='https://i.imgur.com/zx6GoZ9.png' alt='4.2.1' width='500px' /><br />

Once the reaction system is enabled (see **2.0** part), in the `Configuration of Emojis` tab, change the name by replacing the content of the text box associated with each emoji.

### 4.3 How to reset the votes of a course?

<img src='https://i.imgur.com/1LFTSgP.png' alt='4.3.1' width='300px' /><br />

In the `Reset reactions` tab, press the button above, a confirmation message will appear. Confirm and you will be automatically redirected to the course page. It will delete all votes of all activities the course.

<img src='https://i.imgur.com/zrqJ4hF.png' alt='4.3.2' width='800px' />

## Menu

### 5.0 - How to access the overview?

<img src='https://i.imgur.com/Cj2C9Kx.png' alt='5.0.1' width='100px' /><br />

In the block content, a menu button, only visible by teachers, redirects to a page containing several tabs, including `Overview`.

<img src='https://i.imgur.com/5UOa9Wy.png' alt='5.0.2' width='800px' /><br />

This page gives the details of the course votes in a readable table.

**Reminder**: Only teachers, editingteacher, manager and coursecreator have the `Menu` button visible.

### 5.1 - How to modify the display in number of votes, or in percentage?

<img src='https://i.imgur.com/KRW8bfw.png' alt='5.1.1' width='800px' /><br />

By default, the votes are displayed in percentage, click on one of the votes and the display will be modified in number of votes.

<img src='https://i.imgur.com/pGf6pm2.png' alt='5.1.2' width='800px' />

### 5.2 - How to get the details of users who voted for an activity?

<img src='https://i.imgur.com/VlbBIKQ.png' alt='5.2.1' width='800px' /><br />

Click on the `+` to the right of the line and the details of the users associated with their voted reaction will be displayed.

<img src='https://i.imgur.com/sWFf3jG.png' alt='5.2.2' width='800px' />

### 6.0 - How to access the export menu?

<img src='https://i.imgur.com/TFd4KdX.png' alt='6.0.1' width='300px' /><br />
 
Click on the second tab named `Export`.

### 6.1 - How to export the votes of a course?

<img src='https://i.imgur.com/NMyhlH4.png' alt='6.1.1' width='300px' /><br />

Choose its extension between CSV, OpenOffice or Excel and click on the associated button. The download of the table will start automatically.

## Administration

### 7.0 - How to enable/disable the reaction system on the site?

<img src='https://i.imgur.com/S025OiV.png' alt='7.0.1' width='300px' /><br />

In `Site Administration > Plugins > Blocks > Point of View` menu, enable/disable the reaction system by checking/un-checking the box above.

### 7.1 - How to set default emojis for the website?

<img src='https://i.imgur.com/IF606jI.png' alt='7.1.1' width='700px' /><br />

In `Site Administration > Plugins > Blocks > Point of View` menu, enable emojis customization by checking the box above and provide the required 11 files in the file area (see **4.0** part).

### 7.2 - How to customize the color of the difficulty tracks on the website?

<img src='https://i.imgur.com/dl6uS9Z.png' alt='7.2.1' width='400px' /><br />

In `Site Administration > Plugins > Blocks > Point of View` menu, define the color of the associated track.

